%{
#include <stdio.h>
#include <ctype.h>
int reg[26];
%}
%start zeilen
%token  ZIFFER BUCHSTABE
%left  '|'
%left  '&'
%left  '+'  '-'
%left  '*'  '/'  '%'
%left  '^'

%%

zeilen  :  eingabe  '\n'
        |  zeilen  eingabe  '\n'
        |  error  '\n'  {yyerrok;}
        ;

eingabe :  ausdruck  {printf("%d\n",$1);}
        |  BUCHSTABE '=' eingabe  {reg[$1]=$3;$$=$3;}
        ;

ausdruck:  '('  ausdruck  ')'  {$$=$2;}
        |  ausdruck '+' ausdruck  {$$=$1+$3;}
        |  ausdruck '-' ausdruck  {$$=$1-$3;}
        |  ausdruck '*' ausdruck  {$$=$1*$3;}
        |  ausdruck '/' ausdruck  {$$=$1/$3;}
        |  ausdruck '%' ausdruck  {$$=$1%$3;}
        |  ausdruck '&' ausdruck  {$$=$1&$3;}
        |  ausdruck '|' ausdruck  {$$=$1|$3;}
        |  ausdruck  '^' ausdruck  {$$=potenz($1,$3);}
        |  '-' ausdruck  {$$=-$2;}
        |  BUCHSTABE  {$$=reg[$1];}
        |  zahl
        ;

zahl    :  ZIFFER
        |  zahl  ZIFFER  {$$=$1*10+$2;}
        ;

%%

int potenz(int a, int b)
{  int i, ergeb=1;
   for (i=1 ; i<=b ; i++)
      ergeb*=a;
   return(ergeb);
}

yylex()
{
   int zeich;
   while ((zeich=getchar())==' ' || zeich=='\t')
      ;    /* Leer- und Tabulatorzeichen ueberlesen */
   if (islower(zeich)) {
      yylval=zeich-'a';
      return(BUCHSTABE);
   } else if (isdigit(zeich)) {
      yylval=zeich-'0';
      return(ZIFFER);
   } else
      return(zeich);
}

void yyerror(char *s)   /*........... unter LINUX notwendig */
{
    fprintf(stderr, "%s\n", s);
}

int main(int argc, char *argv[])
{
    yyparse();
    return(0);
}
