%{
int zeilennummer;
#define prompt1    printf("%5d : ", ++zeilennummer);
#define prompt2    printf("%5d : ", zeilennummer);
%}
%start zeilen
%token ZAHL

%%

zeilen  :   ausdruck '\n'  {printf("%d\n",$1); prompt1;}
        |   zeilen ausdruck '\n' {printf("%d\n",$2); prompt1;}
        |   error '\n'  {yyerrok; prompt2}
        ;

ausdruck:   ausdruck '+' term  {$$= $1 + $3;}
        |   ausdruck '-' term  {$$= $1 - $3;}
        |   term
        ;

term    :   term     '*' factor {$$ = $1 * $3;}
        |   term     '/' factor {$$ = $1 * $3;}
        |   factor
        ;

factor  :   ZAHL
        |   '-'  ZAHL  {$$ = -$2;} 
        ;

%%

#include "lex.yy.c"

void yyerror(char *s)
{
    fprintf(stderr, "Fehler in Zeile %d ", zeilennummer);
    if (yychar == '\n')
       fprintf(stderr, "(Ausdruck nicht abgeschlossen)\n", yychar);
    else if (yychar == ZAHL)
       fprintf(stderr, "(fehlender Operator)\n", yychar);
    else
       fprintf(stderr, "(unerlaubtes Zeichen %c)\n", yychar);
}

int main(void)
{
    prompt1;
    yyparse();
    return(0);
}

